---
title: Reflect.deleteProperty()
slug: Web/JavaScript/Reference/Global_Objects/Reflect/deleteProperty
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Reference
  - Reflect
---
<div>{{JSRef}}</div>

<p>The static <code><strong>Reflect</strong></code><strong><code>.deleteProperty()</code></strong> method allows to delete properties. It is like the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/delete"><code>delete</code> operator</a> as a function.</p>

<div>{{EmbedInteractiveExample("pages/js/reflect-deleteproperty.html", "taller")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Reflect.deleteProperty(<var>target</var>, <var>propertyKey</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>target</var></code></dt>
 <dd>The target object on which to delete the property.</dd>
 <dt><code><var>propertyKey</var></code></dt>
 <dd>The name of the property to be deleted.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Boolean")}} indicating whether or not the property was successfully deleted.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>A {{jsxref("TypeError")}}, if <code><var>target</var></code> is not an {{jsxref("Object")}}.</p>

<h2 id="Description">Description</h2>

<p>The <code>Reflect.deleteProperty</code> method allows you to delete a property on an object. It returns a {{jsxref("Boolean")}} indicating whether or not the property was successfully deleted. It is almost identical to the non-strict <a href="/en-US/docs/Web/JavaScript/Reference/Operators/delete"><code>delete</code> operator</a>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_Reflect.deleteProperty">Using <code>Reflect.deleteProperty()</code></h3>

<pre class="brush: js notranslate">let obj = { x: 1, y: 2 }
Reflect.deleteProperty(obj, 'x')  // true
obj                               // { y: 2 }

let arr = [1, 2, 3, 4, 5]
Reflect.deleteProperty(arr, '3')  // true
arr                               // [1, 2, 3, undefined, 5]

// Returns true if no such property exists
Reflect.deleteProperty({}, 'foo')  // true

// Returns false if a property is unconfigurable
Reflect.deleteProperty(Object.freeze({foo: 1}), 'foo')  // false
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-reflect.deleteproperty', 'Reflect.deleteProperty')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Reflect.deleteProperty")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Reflect")}}</li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/delete"><code>delete</code> operator</a></li>
</ul>
